VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Form1"
   ClientHeight    =   4065
   ClientLeft      =   2835
   ClientTop       =   1230
   ClientWidth     =   5625
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   271
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   375
   Begin VB.Label lblDistance 
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   1095
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Click four times to define two line segments."
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_X(0 To 3) As Single
Private m_Y(0 To 3) As Single
Private m_NextPoint As Integer

' Calculate the distance between the point and the segment.
Private Function DistToSegment(ByVal px As Single, ByVal py As Single, ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, ByRef near_x As Single, ByRef near_y As Single) As Single
Dim dx As Single
Dim dy As Single
Dim t As Single

    dx = X2 - X1
    dy = Y2 - Y1
    If dx = 0 And dy = 0 Then
        ' It's a point not a line segment.
        dx = px - X1
        dy = py - Y1
        near_x = X1
        near_y = Y1
        DistToSegment = Sqr(dx * dx + dy * dy)
        Exit Function
    End If

    ' Calculate the t that minimizes the distance.
    t = ((px - X1) * dx + (py - Y1) * dy) / (dx * dx + dy * dy)

    ' See if this represents one of the segment's
    ' end points or a point in the middle.
    If t < 0 Then
        dx = px - X1
        dy = py - Y1
        near_x = X1
        near_y = Y1
    ElseIf t > 1 Then
        dx = px - X2
        dy = py - Y2
        near_x = X2
        near_y = Y2
    Else
        near_x = X1 + t * dx
        near_y = Y1 + t * dy
        dx = px - near_x
        dy = py - near_y
    End If

    DistToSegment = Sqr(dx * dx + dy * dy)
End Function
' Calculate the distance between
' the segment (X11, Y11)-(X12, Y12) and
' the segment (X21, Y21)-(X22, Y22).
' Return the distance. Return the closest points
' on the segments through parameters
' (near_x1, near_y1) and (near_x2, near_y2).
Private Function DistBetweenSegments(ByVal X11 As Single, ByVal Y11 As Single, ByVal X12 As Single, ByVal Y12 As Single, ByVal X21 As Single, ByVal Y21 As Single, ByVal X22 As Single, ByVal Y22 As Single, ByRef near_x1 As Single, ByRef near_y1 As Single, ByRef near_x2 As Single, ByRef near_y2 As Single) As Single
Dim dx As Single
Dim dy As Single
Dim t As Single
Dim best_dist As Single
Dim test_dist As Single
Dim test_x As Single
Dim test_y As Single

    ' See if the segments intersect.
    If SegmentsIntersect(X11, Y11, X12, Y12, X21, Y21, X22, Y22, near_x1, near_y1) Then
        ' The segments intersect.
        DistBetweenSegments = 0
        near_x2 = near_x1
        near_y2 = near_y1
        Exit Function
    End If

    ' Check (X11, Y11) with segment 2.
    test_dist = DistToSegment(X11, Y11, X21, Y21, X22, Y22, test_x, test_y)
    best_dist = 1E+38
    If test_dist < best_dist Then
        best_dist = test_dist
        near_x1 = test_x
        near_y1 = test_y
        near_x2 = X11
        near_y2 = Y11
    End If

    ' Check (X12, Y12) with segment 2.
    test_dist = DistToSegment(X12, Y12, X21, Y21, X22, Y22, test_x, test_y)
    If test_dist < best_dist Then
        best_dist = test_dist
        near_x1 = X12
        near_y1 = Y12
        near_x2 = test_x
        near_y2 = test_y
    End If

    ' Check (X21, Y21) with segment 1.
    test_dist = DistToSegment(X21, Y21, X11, Y11, X12, Y12, test_x, test_y)
    If test_dist < best_dist Then
        best_dist = test_dist
        near_x1 = test_x
        near_y1 = test_y
        near_x2 = X21
        near_y2 = Y21
    End If

    ' Check (X22, Y22) with segment 1.
    test_dist = DistToSegment(X22, Y22, X11, Y11, X12, Y12, test_x, test_y)
    If test_dist < best_dist Then
        best_dist = test_dist
        near_x1 = test_x
        near_y1 = test_y
        near_x2 = X22
        near_y2 = Y22
    End If

    DistBetweenSegments = best_dist
End Function
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim dist As Single
Dim near_x1 As Single
Dim near_y1 As Single
Dim near_x2 As Single
Dim near_y2 As Single

    If m_NextPoint = 4 Then
        Me.Cls
        m_NextPoint = 0
    End If

    m_X(m_NextPoint) = X
    m_Y(m_NextPoint) = Y
    Me.Circle (X, Y), 3

    If m_NextPoint = 1 Then
        Me.Line (m_X(0), m_Y(0))-(m_X(1), m_Y(1))
    ElseIf m_NextPoint = 3 Then
        Me.Line (m_X(2), m_Y(2))-(m_X(3), m_Y(3))

        dist = DistBetweenSegments(m_X(0), m_Y(0), m_X(1), m_Y(1), m_X(2), m_Y(2), m_X(3), m_Y(3), near_x1, near_y1, near_x2, near_y2)

        lblDistance.Caption = Format$(dist, "0.00")
        Me.Circle (near_x1, near_y1), 3, vbBlue
        Me.Circle (near_x2, near_y2), 3, vbBlue
        Me.Line (near_x1, near_y1)-(near_x2, near_y2), vbBlue
    End If

    m_NextPoint = m_NextPoint + 1
End Sub

' Return True if the segments intersect.
Private Function SegmentsIntersect(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, ByVal A1 As Single, ByVal B1 As Single, ByVal A2 As Single, ByVal B2 As Single, ByRef intersect_x As Single, ByRef intersect_y As Single) As Boolean
Dim dx As Single
Dim dy As Single
Dim da As Single
Dim db As Single
Dim t As Single
Dim s As Single

    dx = X2 - X1
    dy = Y2 - Y1
    da = A2 - A1
    db = B2 - B1
    If (da * dy - db * dx) = 0 Then
        ' The segments are parallel.
        SegmentsIntersect = False
        Exit Function
    End If
    
    s = (dx * (B1 - Y1) + dy * (X1 - A1)) / (da * dy - db * dx)
    t = (da * (Y1 - B1) + db * (A1 - X1)) / (db * dx - da * dy)
    If s >= 0# And s <= 1# And _
       t >= 0# And t <= 1# _
    Then
        ' The segments intersect.
        SegmentsIntersect = True
        intersect_x = X1 + t * dx
        intersect_y = Y1 + t * dy
    Else
        ' The segments do not intersect.
        SegmentsIntersect = False
    End If
End Function
